;Max lngd = 40


#include "ti86asm.inc"

Line1 = $8200       ;Length, coords y,x
Line2 = Line1+80
Line3 = Line2+80

LightPage = $8400
DarkPage = $8800
Map = $8C00

.org _asm_exec_ram

    nop
    jp ProgStart
    .dw 0
    .dw ShellTitle

ShellTitle:
    .db "Brainstorm v1.0 - TCPA",0

ProgStart:

    call _runindicoff
    call _flushallmenus

DoMainMenu:
    call _clrLCD

    call DoMenuGraphics

    ld hl,$0802
    ld (_curRow),hl
    ld hl,StartTxt
    call _puts
    ld bc,$0603
    ld (_curRow),bc
    call _puts
    ld bc,$0404
    ld (_curRow),bc
    call _puts
    ld bc,$0805
    ld (_curRow),bc
    call _puts

    xor a
    ld b,a
    ld (MenuPosition),a
    call DrawBar
   
MenuKeyLoop:
    call _getky
    cp K_DOWN
    jr z,MoveMenuDown
    cp K_UP
    jr z,MoveMenuUp
    cp K_EXIT
    jp z,Quit
    cp K_ENTER
    jr z,HandleSelection
    cp K_SECOND
    jr z,HandleSelection
    jr MenuKeyLoop

MoveMenuDown:
    ld a,(MenuPosition)
    ld b,a
    push af
    call DrawBar
    pop af
    cp 3
    jr z,MenuCommon
    inc a
MenuCommon:
    ld (MenuPosition),a
    ld b,a
    call DrawBar
    jr MenuKeyLoop

MoveMenuUp:
    ld a,(MenuPosition)
    ld b,a
    push af
    call DrawBar
    pop af
    or a
    jr z,MenuCommon
    dec a
    jr MenuCommon

HandleSelection:
    call _getky
    ld a,(MenuPosition)
    add a,a
    ld hl,MenuTable
    ld e,a
    ld d,0
    add hl,de
    ld a,(hl)
    inc hl
    ld h,(hl)
    ld l,a
    jp (hl)

MenuTable:
    .dw NewGame,ViewHighscore,Instructions,Quit

ClearMiddle:
    ld hl,$FC00+((12*16)+2)
    ld de,4
    ld c,36
    xor a
ClearMiddleLoop:
    ld b,12
ClearMiddleLoop2:
    ld (hl),a
    inc hl
    djnz ClearMiddleLoop2
    add hl,de
    dec c
    jr nz,ClearMiddleLoop

DrawMenuLines:
    ld ix,$FC00+((12*16)+2)
    ld b,36
    ld a,%10000000
    ld c,%00000001
    ld de,16
DrawMenuLinesLoop:
    ld (ix),a
    ld (ix+11),c
    add ix,de
    djnz DrawMenuLinesLoop
    ret

DrawInstructionsText:
    ld bc,12*256+21
    ld (_penCol),bc
    ld b,6
DITLoop:
    call _vputs
    ld a,21
    ld (_penCol),a
    ld a,(_penRow)
    add a,6
    ld (_penRow),a
    djnz DITLoop
    ret

Quit:
    ld hl,_asapvar
    rst 20h
    rst 10h
    ld a,b
    ld hl,HighScores-_asm_exec_ram+4
    add hl,de
    adc a,0
    call _set_abs_dest_addr
    xor a
    ld hl,HighScores
    call _set_abs_src_addr
    ld hl,44
    call _set_mm_num_bytes
    call _mm_ldir
    set graphdraw,(iy+graphflags)
    call _clrScrn
    jp _homeup

ViewHighscore:
    call ClearMiddle
    ld hl,12*256+21
    ld (_penCol),hl
    ld hl,HiTxt
    call _vputs

    ld hl,21*256+21
    ld (_penCol),hl
    ld hl,HighScores
    ld b,4
HighscoreLoop:
    push bc
    call _vputs
    ld a,96
    ld (_penCol),a
    call DisplayHLInd
    ld a,(_penRow)
    add a,6
    ld (_penRow),a
    ld a,21
    ld (_penCol),a
    pop bc
    djnz HighscoreLoop

    call _getkey
    jp DoMainMenu

DisplayHLInd:
    ld e,(hl)
    inc hl
    ld d,(hl)
    inc hl
    ex de,hl
    ld b,4
DisplayHLIndLoop:
    call _divHLby10
    add a,'0'
    push de
    call _vputmap
    pop de
    ld a,(_penCol)
    sub 8
    ld (_penCol),a
    djnz DisplayHLIndLoop
    ex de,hl
    ret


Instructions:
    ld hl,InstructionsText
    ld b,5
InstructionsLoop:
    push bc
    push hl
    call ClearMiddle
    pop hl
    call DrawInstructionsText
    push hl
    call _getkey
    pop hl
    pop bc
    djnz InstructionsLoop
    jp DoMainMenu

NewGame:
    call OpenGray
    ld hl,100
    ld (ScoreToBeat),hl
    ld (CurrentScore),hl
    ld a,1
    ld (CurrentLevel),a
StartNewLevel:
    xor a
    ld (CurrentLine),a
    ld (Timer),a
    ld (Drawing),a
    ld (Bonus),a
    ld b,a
    call SetLineToB
    ld a,(CurrentLevel)
    dec a
    ld l,a
    ld h,0
    add hl,hl   ;*2
    add hl,hl   ;*4
    ld b,h
    ld c,l
    add hl,hl   ;*8
    add hl,hl   ;*16
    ld d,h
    ld e,l
    add hl,hl   ;*32
    add hl,hl   ;*64
    add hl,de   ;*80
    add hl,bc   ;*84
    ld de,Levels
    add hl,de
    ld de,Map
    ld bc,84
    ldir
    ld a,48
    ld (CursorX),a
    ld a,28
    ld (CursorY),a
    ld hl,Drawing
    ld d,h
    ld e,l
    inc de
    ld (hl),0
    ld bc,18
    ldir

    ld hl,Line1
    ld d,h
    ld e,l
    inc de
    ld (hl),0
    ld bc,239
    ldir

    ld hl,Line1
    ld c,52
    ld a,26
    ld b,3
    ld de,74
SomeLoop2:
    push bc
    ld b,3
Loop:
    ld (hl),c
    inc hl
    ld (hl),a
    inc hl
    inc c
    djnz Loop
    add hl,de
    add a,22
    pop bc
    djnz SomeLoop2

    ld a,20
    ld (BallX),a
    ld a,10
    ld (BallY),a

    ld a,100
    ld (Time),a

    ld hl,$1414
    ld (CursorCoords),hl

    call ClearVirtScreens
    call DrawBox
    call RestoreMap
    call RestoreLines
    call UpdateCursor
    call UpdateBall
    call UpdateScreen
    call WaitForEnter

MainLoop:
    call ClearVirtScreens
    call DrawBox
    call RestoreMap
    call RestoreLines

    call GetKeys

    call UpdateCursor

    call UpdateBall
    call UpdateTimer

    call UpdateScreen

    jr MainLoop


UpdateTimer:
    ld a,(Timer)
    inc a
    cp 15
    jr z,TimerRounded
    ld (Timer),a
    ret
TimerRounded:
    ld a,(Time)
    or a
    jp z,TimeUp
    dec a
    ld (Time),a
    xor a
    ld (Timer),a
    call UpdateScore
    ret


TimeUp:
    call UpdateScreen
    ld hl,(CurrentScore)
    ld d,h
    ld e,l
    ld hl,(ScoreToBeat)
    and a
    sbc hl,de
    jr c,ScoreWasBeaten
    jp HandleGameOver

ScoreWasBeaten:
    call DisplayLevelClear
    call Delay

    ld a,(CurrentLevel)
    ld b,a
    ld a,(NumberOfLevels)
    cp b
    jr nz,ChangeLevel
    jp HandleGameOver

ChangeLevel:
    ld a,b
    inc a
    ld (CurrentLevel),a
    ld hl,(CurrentScore)
    ld (ScoreToBeat),hl
    pop hl                  ;removing old call from stack
    jp StartNewLevel
    
HandleGameOver:
    call DisplayGameOver
    call Delay
    call Delay
    call CloseGray
    call DoMenuGraphics

    ld ix,HighScores
    ld de,(CurrentScore)
    xor a
    ld b,4
HandleGameOverLoop:
    push bc
    ld l,(ix+9)
    ld h,(ix+10)
    and a
    sbc hl,de
    jr c,NewHighScore
    inc a
    ld bc,11
    add ix,bc
    pop bc
    djnz HandleGameOverLoop
    jp Quitting

NewHighScore:
    pop bc
    push af
    dec b
    jr z,StartEnteringInitials


    ld a,b
    add a,a     ;*2
    add a,a     ;*4
    ld c,a
    add a,a     ;*8
    add a,c     ;*12
    sub b       ;*11
    ld c,a
    ld b,0
    ld hl,HighScoresEnd-12
    ld de,HighScoresEnd-1
    lddr

StartEnteringInitials:
    ld hl,12*256+21
    ld (_penCol),hl
    ld hl,NewHighTxt
    call _vputs
    ld bc,18*256+21
    ld (_penCol),bc
    call _vputs
    pop af
    call EnterInitials
    pop hl
    jp ViewHighscore

EnterInitials:
    ld b,a
    add a,a     ;*2
    add a,a     ;*4
    ld c,a
    add a,a     ;*8
    add a,c     ;*12
    sub b       ;*11
    ld c,a
    ld b,0
    ld hl,HighScores
    add hl,bc
    push hl
    xor a
    ld (NumberOfChars),a
    ld a,' '
    ld b,8
InitialsLoop1:
    ld (hl),a
    inc hl
    djnz InitialsLoop1
    inc hl
    ld de,(CurrentScore)
    ld (hl),e
    inc hl
    ld (hl),d

InitKeyLoop:
    call _getky
    cp K_DEL
    jp z,BackUp
    cp K_ENTER
    jp z,DoneEntering
    cp $0A
    jr c,InitKeyLoop
    cp $2F
    jr nc,InitKeyLoop
    sub $0A
    ld e,a
    ld d,0
    ld hl,KeyTable
    add hl,de
    ld a,(hl)
    or a
    jr z,InitKeyLoop
GotKey:
    ld b,a
    ld a,(NumberOfChars)
    cp 8
    jr z,InitKeyLoop
    pop hl
    ld a,b
    ld (hl),a
    ld a,(NumberOfChars)
    cp 7
    jr z,SkipIncingOfCursor
    inc hl
SkipIncingOfCursor:
    push hl
    ld hl,$0404         ;x,y
    ld (_curRow),hl
    inc a
    ld (NumberOfChars),a
    ld c,a
    ld a,(_curCol)
    add a,c
    ld (_curCol),a
    ld a,b
    call _putc
    jr InitKeyLoop

BackUp:
    ld a,(NumberOfChars)
    or a
    jr z,InitKeyLoop
    ld b,a
    pop hl
    ld a,' '
    ld (hl),a
    dec hl
    push hl
    ld a,b
    dec a
    ld (NumberOfChars),a
    ld hl,$0404         ;x,y
    ld (_curRow),hl
    ld a,(_curCol)
    add a,b
    ld (_curCol),a
    ld a,' '
    call _putc
    jr InitKeyLoop

DoneEntering:
    pop hl
    ret

KeyTable:
    .db 'X','T','O','J','E',0,0
    .db ' ','W','S','N','I','D',0,0
    .db 'Z','V','R','M','H','C',0,0
    .db 'Y','U','Q','L','G','B',0,0,0,0
    .db 'P','K','F','A'

Delay:
    ld bc,$0000
DelayLoop
    dec bc
    push ix
    push ix
    pop ix
    pop ix
    ld a,b
    or c
    jr nz,DelayLoop
    ret

WaitForEnter:
    ld a,%01111101
    out (1),a
    nop
    nop
    in a,(1)
    bit 0,a
    jr nz,WaitForEnter
    ret

DisplayGameOver:
    ld de,GameOverPic
    ld hl,DarkPage+(18*16+4)
    ld c,19
    call Draw4x4
    ld de,GameOverPic
    ld hl,LightPage+(18*16+4)
    ld c,19
    call Draw4x4
    jp UpdateScreen

DisplayLevelClear:
    ld de,LevelDonePic
    ld hl,DarkPage+(18*16+4)
    ld c,19
    call Draw4x4
    ld de,LevelDonePic
    ld hl,LightPage+(18*16+4)
    ld c,19
    call Draw4x4
    jp UpdateScreen
    

UpdateScore:
    ld hl,Map
    ld a,(BallY)
    sra a
    sra a
    sra a
    ld c,a
    ld a,(BallX)
    sra a
    sra a
    sra a
    ld b,a
    or a
    jr z,UpdateScoreAfterLoop1
UpdateScoreLoop1:
    inc hl
    djnz UpdateScoreLoop1
UpdateScoreAfterLoop1:
    ld a,c
    or a
    jr z,FoundPositionOnMap
    xor a
    ld de,12
UpdateScoreLoop2:
    add hl,de
    dec c
    cp c
    jr nz,UpdateScoreLoop2
FoundPositionOnMap:
    ld a,(hl)
    push af
    cp 1
    call z,IncScore
    pop af
    push af
    cp 2
    call z,DecScore
    pop af
    cp 3
    call z,Warp
    ret

GetKeys:
    ld a,%01111110
    out (1),a
    in a,(1)
    push af
    bit 3,a
    call z,MoveUp
    pop af
    push af
    bit 2,a
    call z,MoveRight
    pop af
    push af
    bit 1,a
    call z,MoveLeft
    pop af
    bit 0,a
    call z,MoveDown

    ld a,%00111111
    out (1),a
    in a,(1)

    bit 5,a
    jp z,SecondPressed

    bit 6,a
    jp z,Quitting

    ret

Quitting:
    call CloseGray
    pop hl
    call _getky
    jp DoMainMenu

LineTable:
    .dw Line1,Line2,Line3,Line3

SecondPressed:
    ld a,(CursorX)
    cp 95
    jp nc,CursorNotInArea
    ld a,(CurrentLine)
    cp 3
    jp z,CursorNotInArea
    ld hl,(CurLine)
    ld a,(hl)
    ld b,a
    ld a,(CursorY)
    cp b
    jr nz,SkipSomething
    inc hl
    ld a,(hl)
    ld b,a
    ld a,(CursorX)
    cp b
    ret z
    ld a,(Drawing)
    or a
    ret nz
    
SkipSomething:
    ld a,1
    ld (Drawing),a
    ld a,(CursorX)
    ld (GoalX),a
    ld a,(CursorY)
    ld (GoalY),a

    ld b,a
    ld hl,(CurLine)
    ld a,(hl)   ;a=lineY

    cp b
    jr nc,MinskarY

;Fixar deltaY
    ld c,a
    ld a,b
    sub c
    ld (DeltaY),a


    ld a,$3C    ;$3C = inc a
    ld (qincordec1),a       ;temporrt, byt om behvs
    jr KollarOmX
MinskarY:
;Fixar deltaY
    sub b
    ld (DeltaY),a

    ld a,$3D    ;$3D = dec a
    ld (qincordec1),a

KollarOmX:
    inc hl
    ld a,(GoalX)
    ld b,a
    ld a,(hl)   ;a=lineX

    cp b
    jr nc,MinskarX

;Fixar deltaX
    ld c,a
    ld a,b
    sub c
    ld (DeltaX),a

    ld a,$3C
    ld (qincordec2),a
    jr KlartKollat
MinskarX:
;Fixar deltaX
    sub b
    ld (DeltaX),a

    ld a,$3D
    ld (qincordec2),a
KlartKollat:

    ld a,(DeltaY)
    ld b,a
    ld a,(DeltaX)
    cp b
    jr c,BytOrdning
    ld hl,XCur
    ld (Storre),hl
    ld hl,YCur
    ld (Mindre),hl
    ld a,(qincordec1)
    ld b,a
    ld a,(qincordec2)
    ld (qincordec1),a
    ld a,b
    ld (qincordec2),a
    jr CalculateRun
BytOrdning:
    ld hl,YCur
    ld (Storre),hl
    ld hl,XCur
    ld (Mindre),hl
    ld a,(DeltaY)
    ld b,a
    ld a,(DeltaX)
    ld (DeltaY),a
    ld a,b
    ld (DeltaX),a

CalculateRun:
    ld a,(DeltaX)
    ld h,0
    ld l,a
    ld a,(DeltaY)
    call _divHLbyA

    ld (Restdel),a
    ld a,l
    ld (Heldel),a
    ld (HelCount),a
    xor a
    ld (More),a
    ld (MoreIsFull),a
    ret

RestoreLines:
    ld a,(Drawing)
    or a
    jp z,NotDrawing

    ld hl,(CurLine)
    ld bc,77
    add hl,bc
    ld d,h
    ld e,l
    inc de
    inc de
    ld bc,78
    lddr

    ld hl,(CurLine)
    inc hl
    inc hl
    ld a,(hl)       ;Ycoord of top pixel
    ld (YCur),a
    inc hl
    ld a,(hl)
    ld (XCur),a

    ld hl,$0000
Storre = $ - 2

    ld a,(hl)


    .db $3C         ;selfmod. to inc(3C) or dec(3D)/ inc a or dec a
qincordec1 = $ - 1

    ld (hl),a

    ld a,(MoreIsFull)
    or a
    jr z,Continue
    xor a
    ld (MoreIsFull),a
    jp DoneUpdatingLine

Continue:   
    ld a,(HelCount)
    dec a
    ld (HelCount),a
    jr nz,DoneUpdatingLine  ;Nu r strre delen klar

    ld hl,$0000
Mindre = $ - 2

    ld a,(hl)     ;Ycoord of top pixel

    .db $3C         ;selfmod. to inc(3C) or dec(3D)/ inc a or dec a
qincordec2 = $ - 1

    ld (hl),a

    ld a,(Restdel)
    ld b,a
    ld a,(More)
    add a,b
    ld (More),a
    ld b,a          ;B = Moredelen

    ld a,(DeltaY)
    cp b
    jr z,NuKommerJagIntePaEttNamn
    jr nc,Continue2

NuKommerJagIntePaEttNamn:    
    ld c,a
    ld a,b
    sub c
    ld (More),a
    ld a,1
    ld (MoreIsFull),a

Continue2:
    ld a,(Heldel)
    ld (HelCount),a

DoneUpdatingLine:
    ld hl,(CurLine)
    ld a,(YCur)
    ld (hl),a
    inc hl
    ld a,(XCur)
    ld (hl),a
    ld b,a
    ld a,(GoalX)
    cp b
    jr nz,NotDrawing
    ld a,(YCur)
    ld b,a
    ld a,(GoalY)
    cp b
    jr nz,NotDrawing
    xor a
    ld (Drawing),a
                    ;Kolla om frdigt ritad
NotDrawing:
    ld hl,Line1
    ld b,120
RLLoop:
    push bc
    ld c,(hl)
    inc hl
    ld b,(hl)
    inc hl
    push hl
    call SetPixel
    pop hl
    pop bc
    djnz RLLoop
    ret

CursorNotInArea:
    ld a,(CursorX)
    cp 102
    ret c
    ld a,(CursorY)
    cp 34
    ret c
    cp 38
    jr nc,NotFirstLine
    ld b,0
    xor a
    ld (Bonus),a
    jr SetLineToB
NotFirstLine:
    cp 40
    ret c
    cp 44
    jr nc,NotSecondLine
    ld b,1
    xor a
    ld (Bonus),a
    jr SetLineToB
NotSecondLine:
    cp 46
    ret c
    cp 50
    jr nc,NotThirdLine
    ld b,2
    xor a
    ld (Bonus),a
    jr SetLineToB
NotThirdLine:
    cp 52
    ret c
    ld a,1
    ld (Bonus),a
    ld b,3

SetLineToB:
    ld a,(Drawing)
    or a
    ret nz
    ld a,b
    ld (CurrentLine),a
    add a,a
    ld c,a
    ld b,0
    ld hl,LineTable
    add hl,bc
    ld a,(hl)
    inc hl
    ld h,(hl)
    ld l,a
    ld (CurLine),hl
    ret


MoveUp:
    ld a,(CursorY)
    dec a
    or a
    ret z
    ld (CursorY),a
    ret

MoveRight:
    ld a,(CursorX)
    inc a
    cp 120
    ret z
    ld (CursorX),a
    ret

MoveLeft:
    ld a,(CursorX)
    dec a
    or a
    ret z
    ld (CursorX),a
    ret

MoveDown:
    ld a,(CursorY)
    inc a
    cp 55
    ret z
    ld (CursorY),a
    ret

UpdateBall:
    xor a
    ld (Bounced),a
    ld a,(BallXDir)
    ld (OldXDir),a
    ld a,(BallYDir)
    ld (OldYDir),a
    ld a,(BallX)
    cp 2
    push af
    call c,SetRightDir
    pop af
    cp 93
    call nc,SetLeftDir
    ld a,(BallY)
    cp 2
    push af
    call c,SetDownDir
    pop af
    cp 53
    call nc,SetUpDir


;Checking if ball is colliding with line


    ld a,(BallY)
    ld c,a
    ld a,(BallX)
    ld d,a
    ld hl,(BallXDir)    ;h=ydir l=xdir
    push hl
    xor a
    cp h
    push af
    call nz,IncingY
    pop af
    call z,DeccingY

    ld e,0          ;0=Y 1=X
    call CheckOneWay

    ld a,(BallY)
    ld c,a
    ld a,(BallX)
    ld d,a
    pop hl
    push hl
    xor a
    cp l
    push af
    call nz,IncingX
    pop af
    call z,DeccingX

    ld e,1
    call CheckOneWay

    pop hl
    ld a,(Bounced)
    or a
    jr nz,ContinueWithBall
    ld a,(BallY)
    ld c,a
    ld a,(BallX)
    ld d,a
    xor a
    cp h            ;Ydir=0?
    jr nz,OjdaEnTill
    dec c
    jr Nanting
OjdaEnTill:
    inc c
    inc c
Nanting:
    cp l            ;Xdir=0?
    jr nz,AnnuEn
    dec d
    jr NantingIgen
AnnuEn:
    inc d
    inc d
NantingIgen:
    ld e,2
    call CheckOneWay

ContinueWithBall:
    ld a,(Bounced)
    or a
    call nz,CheckIfBackInOriginal    
    ld a,(BallXDir)
    or a
    ld a,(BallX)
    jr z,DecX
    inc a
    ld (BallX),a
    jr DoneWithX
DecX:
    dec a
    ld (BallX),a
DoneWithX:
    ld a,(BallYDir)
    or a
    ld a,(BallY)
    jr z,DecY
    inc a
    ld (BallY),a
    jr DoneWithAll
DecY:
    dec a
    ld (BallY),a
DoneWithAll:

    jp PutBall


CheckIfBackInOriginal:
    ld a,(OldXDir)
    ld b,a
    ld a,(BallXDir)
    cp b
    ret nz
    ld a,(OldYDir)
    ld b,a
    ld a,(BallYDir)
    cp b
    ret nz
    call ChangeYDir
    call ChangeXDir
    ret


SetRightDir:
    ld a,1
    ld (BallXDir),a
    ld (Bounced),a
    ret
SetLeftDir:
    xor a
    ld (BallXDir),a
    inc a
    ld (Bounced),a
    ret
SetUpDir:
    xor a
    ld (BallYDir),a
    inc a
    ld (Bounced),a
    ret
SetDownDir:
    ld a,1
    ld (BallYDir),a
    ld (Bounced),a
    ret


CheckOneWay:
    ld hl,Line1
    ld b,120
CBLLoop:
    ld a,(hl)
    cp c
    jr z,CheckXAlso
    inc hl
    inc hl
    djnz CBLLoop
    ret
CheckXAlso:
    inc hl
    ld a,(hl)
    inc hl
    cp d
    call z,Bounce
    djnz CBLLoop
    ret

Bounce:
    xor a
    cp e
    jr nz,BounceX
    call ChangeYDir
    ld a,1
    ld (Bounced),a
    ret
BounceX:
    ld a,e
    cp 2
    call z,ChangeYDir
    call ChangeXDir
    ld a,1
    ld (Bounced),a
    ret

IncingY:
    inc c
    inc c
    cp l
    ret z
    inc d
    ret

DeccingY:
    dec c
    cp l
    ret z
    inc d
    ret

IncingX:
    inc d
    inc d
    cp h
    ret z
    inc c
    ret

DeccingX:
    dec d
    cp h
    ret z
    inc c
    ret

ClearVirtScreens:
    ld hl,LightPage
    ld d,h
    ld e,l
    inc de
    xor a
    ld (hl),a
    ld bc,2047
    ldir
    ret

RestoreMap:
    xor a
    ld (MapX),a
    ld (MapY),a
    ld de,Map
RMLoop:
    push de
    ld a,(de)
    add a,a ;*2
    ld hl,Table
    ld c,a
    ld b,0
    add hl,bc
    ld a,(hl)
    inc hl
    ld h,(hl)
    ld l,a
    jp (hl)


Adding:
    ld de,SolidSprite
    ld hl,DarkPage
    jr Common

Subbing:
    ld de,SolidSprite
    ld hl,LightPage
    jr Common

Warping:
    ld de,PrickiSprite
    ld hl,DarkPage

Common:
    call PutTile
Normal:
    call UpdateMapCoords
    pop de
    inc de
    jr RMLoop


UpdateMapCoords:
    ld a,(MapX)
    inc a
    ld (MapX),a
    cp 12
    ret c
    xor a
    ld (MapX),a
    ld a,(MapY)
    inc a
    ld (MapY),a
    cp 7
    ret c
    pop hl
    pop hl
    ret

Table:
    .dw Normal,Adding,Subbing,Warping

ChangeXDir:
    ld a,(BallXDir)
    xor 1
    ld (BallXDir),a
    ld a,1
    ld (Bounced),a
    ret

ChangeYDir:
    ld a,(BallYDir)
    xor 1
    ld (BallYDir),a
    ld a,1
    ld (Bounced),a
    ret


IncScore:
    ld hl,(CurrentScore)
    inc hl
    ld a,(Bonus)
    or a
    jr z,ChangeScoreSkip
    inc hl
ChangeScoreSkip:
    ld (CurrentScore),hl
    ret

DecScore:
    ld hl,(CurrentScore)
    ld a,h
    or l
    jr z,ChangeScoreSkip
    dec hl
    ld a,(Bonus)
    or a
    jr z,ChangeScoreSkip
    dec hl
    jr ChangeScoreSkip

Warp:
    ld a,85
    call Random
    add a,4
    ld (BallX),a
    ld a,45
    call Random
    add a,4
    ld (BallY),a
    ret

UpdateScreen:
    ld hl,LightPage
    ld de,_plotSScreen+6
    ld bc,1024
    ldir
    ld de,$FC00
    ld bc,1024
    ldir
    ret


DoMenuGraphics:    
    ld hl,Pic
    ld de,$FC00+16
    ld bc,8*16
    ldir

    ld hl,$FC00
    ld b,160
    call MenuLoop

    ld hl,CopyTxt
    ld bc,50*256+28
    ld (_penCol),bc
    call _vputs
    ld bc,57*256+34
    ld (_penCol),bc
    call _vputs

    ld hl,$FC00+(16*50)
    ld b,224
    call MenuLoop

    ld a,%01010101
    ld l,%01010100
    ld b,36
    ld de,16
    ld ix,$FC00+(12*16)
MenuLoop2:
    ld (ix),a
    ld (ix+1),l
    ld (ix+14),a
    ld (ix+15),l
    add ix,de
    srl l
    ld h,l
    sla a
    ld l,a
    ld a,h
    djnz MenuLoop2
    call DrawMenuLines
    ret




MenuLoop:
    ld a,(hl)
    cpl
    ld (hl),a
    inc hl
    djnz MenuLoop
    ret

DrawBar:
    inc b
    ld hl,-16*8
    ld de,16*8
DBarLoop1:
    add hl,de
    djnz DBarLoop1
    ld de,$FC00+((16*16)+3)
    add hl,de
    ld de,6
    ld b,10
    ld c,7
DBarLoop2:
    ld a,(hl)
    cpl
    ld (hl),a
    inc hl
    djnz DBarLoop2
    add hl,de
    ld b,10
    dec c
    jr nz,DBarLoop2
    ret



;--------------------
; PutTile
;       b = Y
;       c = X
;       de = Sprite
;       hl = Area to put
;--------------------
PutTile: 
    ld bc,(MapCoords)
    push de
    ld de,$80
    and a
    sbc hl,de
    inc b
PTYCoord: 
    add hl,de    
    djnz PTYCoord 
    add hl,bc
    pop de
    ld b,8
CopySprite: 
    push bc
    ld a,(de)

    or (hl)
    
    ld (hl),a
    inc de
    ld bc,16
    add hl,bc
    pop bc
    djnz CopySprite
    ret



DrawBox:
    ld hl,LightPage
    ld de,LightPage+880     ;1008
    ld a,255
    ld b,12
DBLoop1:
    ld (hl),a
    ld (de),a
    inc hl
    inc de
    djnz DBLoop1
    ld ix,LightPage+16
    ld b,54         ;62
    ld de,16
DBLoop2:
    ld (ix+0),$80
    ld (ix+11),$01
    add ix,de
    djnz DBLoop2
    
    ld hl,LightPage+12
    ld de,TitlePic
    ld c,16
    call Draw4x4


DrawingLineIndicators:
    ld hl,LightPage+(18*16+12)
    ld de,TimeTxt
    ld c,5
    call Draw4x4

    ld a,(Time)
    ld l,a
    ld h,0
    ld b,3
    ld d,25
    ld e,119
    call DisplayNumber

    ld hl,(CurrentScore)
    ld b,4
    ld d,58
    ld e,40
    call DisplayNumber

    ld hl,(ScoreToBeat)
    ld b,4
    ld d,58
    ld e,75
    call DisplayNumber

    ld hl,LightPage+(34*16+12)
    push hl
    ld de,LineSpr
    ld c,3
    call Draw4x4
    pop hl
    ld a,(CurrentLine)
    or a
    call z,DrawSelectionBar

    ld hl,LightPage+(40*16+12)
    push hl
    ld de,LineSpr
    ld c,3
    call Draw4x4
    pop hl
    ld a,(CurrentLine)
    dec a
    call z,DrawSelectionBar

    ld hl,LightPage+(46*16+12)
    push hl
    ld de,LineSpr
    ld c,3
    call Draw4x4
    pop hl
    ld a,(CurrentLine)
    cp 2
    call z,DrawSelectionBar

    ld hl,LightPage+(52*16+12)
    push hl
    ld de,BonusTxt
    ld c,5
    call Draw4x4
    pop hl
    ld de,16
    add hl,de
    ld a,(CurrentLine)
    cp 3
    call z,DrawSelectionBar

    ld hl,LightPage
    ld de,DarkPage
    ld bc,1024
    ldir

    ld hl,LightPage+(34*16+12)
    ld de,6*16
    ld a,(CurrentLine)
    ld b,a
    or a
    jr z,JALLSkip
JustALittleLoop:
    add hl,de
    djnz JustALittleLoop
JALLSkip:
    ld de,LineSpr
    ld c,3
    cp 3
    jr nz,JALLSkip2
    ld de,BonusTxt
    ld c,5
JALLSkip2:
    call Draw4x4
    ret

Draw4x4:
DrawTitleLoop1:
    ld b,4
DrawTitleLoop2:
    ld a,(de)
    ld (hl),a
    inc de
    inc hl
    djnz DrawTitleLoop2
    push de
    ld de,12
    add hl,de
    pop de
    dec c
    jr nz,DrawTitleLoop1
    ret

DrawSelectionBar:
    ld de,2*16
    and a
    sbc hl,de
    ld de,Selection
    ld c,7
    call Draw4x4
    ret

PutBall:
    ld bc,(BallCoords)
    call SetPixel
    inc b
    call SetPixel
    inc c
    call SetPixel
    dec b
    call SetPixel
    ret

SetPixel:
    call Find_Pixel
    push af
    or (hl)
    ld (hl),a
    ld de,1024
    add hl,de
    pop af
    or (hl)
    ld (hl),a
    ret


;;; Display Number routine
;;;
;;; Input: hl = number to be displayed
;;;        b  = number of digits to print
;;;        de = coords to print at, d = y, e = x + 12

DisplayNumber:

DispNumLoop:
    push bc
    push de
    call _divHLby10
    push hl
    add a,a
    ld hl,NumberTable
    ld e,a
    ld d,0
    add hl,de
    pop de
    pop bc
    push de
    ld a,c
    sub 4
    ld c,a
    push bc
    ld a,(hl)
    inc hl
    ld h,(hl)
    ld l,a
    call DrawSprite
    pop de
    pop hl
    pop bc
    djnz DispNumLoop
    ret


NumberTable:
    .dw Number0,Number1,Number2,Number3,Number4,Number5,Number6,Number7,Number8,Number9


Random:                ; Creates a random number 0 < x <= A
    push bc
    push de
    push hl
    ld b,a
    ld a,r
    add a,a
    ld hl,0
    ld d,0
    ld e,a
RMul:
    add hl,de
    djnz RMul
    ld a,h
    pop hl
    pop de
    pop bc
    inc a
    ret



; b=y c=x hl=sprite
; don't put y=0

UpdateCursor:
    ld hl,Cursor
    ld bc,(CursorCoords)
DrawSprite:
    push hl
    ld hl,$8400
    ld de,16
UCLoop:
    add hl,de
    djnz UCLoop
    ld a,c
    sra c
    sra c
    sra c
    add hl,bc
    and %00000111
    or a
    jr z,Aligned

    ld b,a
    ld c,8
    pop ix
UCLoop2:
    push bc
    ld d,(ix)
    ld e,0
UCLoop3:
    srl d
    rr e
    djnz UCLoop3
    ld a,d
    ld (Label4),a
    or (hl)
    ld (hl),a
    ld bc,1024
    add hl,bc
    ld a,0
Label4 = $ - 1
    or (hl)
    ld (hl),a
    and a
    sbc hl,bc
    inc hl
    ld a,e
    ld (Label5),a
    or (hl)
    ld (hl),a
    add hl,bc
    ld a,0
Label5 = $ - 1
    or (hl)
    ld (hl),a
    and a
    sbc hl,bc
    ld bc,15
    add hl,bc
    inc ix
    pop bc
    dec c
    jr nz,UCLoop2
    ret

Aligned:
    pop de
    ld b,8
UCALoop:
    ld a,(de)
    ld (Label6),a
    or (hl)
    ld (hl),a
    push bc
    ld bc,1024
    add hl,bc
    ld a,0
Label6 = $ - 1
    or (hl)
    ld (hl),a
    ld bc,1024-16
    and a
    sbc hl,bc
    inc de
    pop bc
    djnz UCALoop
    ret

;------------------------------------------------------
;   FIND_PIXEL by CLEM
;
;   121 cycles  27 bytes    Destroyes : none
;------------------------------------------------------

Find_Pixel:
    ld h,33             ;63
    ld a,c
    add a,a
    add a,a
    ld l,a
    ld a,b
    rra
    add hl,hl
    rra
    add hl,hl
    rra
    or l
    ld l,a
    ld a,b
    and 7
    cpl
    rlca
    rlca
    rlca
    ld (FP_Bit+1),a
    xor a
FP_Bit:
    set 0,a
    ret


;86 Gray Scale routine by Dux Gregis
;super fast and with less flicker than any other routine

OpenGray:
 ld hl,int_start            ;copy interrupt to where it'll exec
 ld de,$8f8f
 ld bc,int_end-int_start
 ldir
 di

 exx                ;put counters etc into shadow registers
 ld b,$3c
 ld c,0
 ld d,3
 ld e,%110110
 ld hl,UserCounter
 exx

 ld hl,$8e00        ;make 256 byte vector table pointing to int
 ld (hl),$8F
 ld bc,256
 ld d,h
 ld e,l
 inc e
 ldir

 ld a,$8E
 ld i,a         ;load interrupt register with vector table
 im 2               ;set interrupt mode
 ei             ;start the interrupt
 ret

CloseGray:
 im 1                   ;reset interrupt mode for OS
 ld a,$3C               ;make sure video mem is active
 out (0),a
clrMem:             ;clear video mem and graph mem
 call _clrLCD
clrGrf:             ;clear graph mem
 ld hl,_plotSScreen+6
 ld d,h
 ld e,l
 inc de
 ld (hl), 0
 ld bc,1024
 ldir
 ret


int_start:      ;this is what is exec when user int is triggered
 ex af,af'
 exx            ;use saved counters etc
 in a,(3)
 bit 1,a
 jr z,leave_int     ;skip when LCD is updating
 inc (hl)           ;inc user counter
 out (c),b
 dec d          
 call z,reset_int_counter
 ld a,d
 cp 1
 call z,change_pages    ;flip pages every once and a while
leave_int:
 in a,(3)           ;this stuff must be done or calc crashes
 rra                ;mysterious stuff from the ROM
 ld a,c
 adc a,9
 out (3),a
 ld a,$0B
 out (3),a
 ex af,af'
 exx
 ei
 reti
int_end:

reset_int_counter:  ;reset int counter d when it is 0
 ld d,3
change_pages:
 ld a,e
 xor b          ;toggle memories
 ld b,a
 ret


;use this when you need a counter

UserCounter     equ     $8f8e


Drawing:
    .db 0
MoreIsFull:
    .db 0
Bounced:
    .db 0

GoalX:  .db 0
GoalY:  .db 0

DeltaX: .db 0
DeltaY: .db 0

XCur:   .db 0
YCur:   .db 0

Heldel:     .db 0
Restdel:    .db 0

HelCount:   .db 0


More:       .db 0

BallCoords:
BallY:    .db 0
BallX:    .db 0

MapCoords:
MapX:   .db 0
MapY:   .db 0

BallXDir:
    .db 0
BallYDir:
    .db 0

CurLine:    .dw $8200
CurrentLine:
    .db 0

CursorCoords:
CursorX:    .db 20
CursorY:    .db 20


OldXDir:    .db 0
OldYDir:    .db 0

Bonus:  .db 0

Time:   .db 0

Timer:  .db 0

MenuPosition:   .db 0

CurrentScore:
    .dw 0
ScoreToBeat:
    .dw 0

NumberOfLevels:
    .db 20

NumberOfChars:
    .db 0

CurrentLevel:
    .db 1

SolidSprite:
    .db %11111111
    .db %11111111
    .db %11111111
    .db %11111111
    .db %11111111
    .db %11111111
    .db %11111111
    .db %11111111

PrickiSprite:
    .db %10011001
    .db %01100110
    .db %10011001
    .db %01100110
    .db %10011001
    .db %01100110
    .db %10011001
    .db %01100110

Cursor:
.db %11100000
.db %11000000
.db %10100000
.db %00010000
.db %00000000
.db %00000000
.db %00000000
.db %00000000

TitlePic:
.db %00011111,%00000000,%00010000,%00000000
.db %00010001,%00000000,%00000000,%00000000
.db %00010001,%00111011,%11010111,%10000000
.db %00011111,%00101000,%01010100,%10000000
.db %00011000,%10100011,%11010100,%10000000
.db %00011000,%10110011,%01010110,%10111100
.db %00011000,%10110011,%01010110,%10000000
.db %00011111,%10110011,%11110110,%10000000
.db %00000000,%00000000,%00000000,%00000000
.db %00000000,%01000000,%00000000,%00000000
.db %00011110,%11101111,%10111011,%11111000
.db %00010010,%01101000,%10101010,%01001000
.db %00010000,%01001000,%10100010,%01001000
.db %00011110,%01001000,%10110011,%01001000
.db %00000110,%01001000,%10110011,%01001000
.db %00011110,%01101111,%10110011,%01001000

BonusTxt:
.db %00000011,%00010010,%01010100,%11000000
.db %00000010,%10101011,%01010101,%00000000
.db %00000011,%00101011,%11010100,%10000000
.db %00000010,%10101010,%11010100,%01000000
.db %00000011,%00010010,%01011101,%10000000

TimeTxt:
.db %00000000,%11101000,%00000000,%00000000
.db %00000000,%01000011,%01000100,%10000000
.db %00000000,%01001010,%10101010,%00000000
.db %00000000,%01001010,%10101100,%10000000
.db %00000000,%01001010,%00100110,%00000000

LineSpr:
.db %00000011,%11111111,%11111111,%11000000
.db %00000011,%11111111,%11111111,%11000000
.db %00000011,%11111111,%11111111,%11000000

Selection:
.db %00111111,%11111111,%11111111,%11111100
.db %00111111,%11111111,%11111111,%11111100
.db %00111111,%11111111,%11111111,%11111100
.db %00111111,%11111111,%11111111,%11111100
.db %00111111,%11111111,%11111111,%11111100
.db %00111111,%11111111,%11111111,%11111100
.db %00111111,%11111111,%11111111,%11111100

GameOverPic:
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%00000000,%00000000,%00000001
.db %10011111,%10000000,%00000000,%00000001
.db %10010000,%10000000,%00000000,%00000001
.db %10010000,%10111011,%11110111,%10000001
.db %10010000,%00001010,%01010110,%10000001
.db %10010011,%10111011,%01010111,%10000001
.db %10010001,%10101011,%01010110,%00000001
.db %10011111,%10111111,%01010111,%10000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000000,%01111111,%00000000,%00000001
.db %10000000,%01000001,%00000000,%00000001
.db %10000000,%01000001,%01010111,%10111001
.db %10000000,%01000001,%01010110,%10101001
.db %10000000,%01000001,%01010111,%10100001
.db %10000000,%01000001,%01110110,%00110001
.db %10000000,%01111111,%01100111,%10110001
.db %10000000,%00000000,%00000000,%00000001
.db %11111111,%11111111,%11111111,%11111111

LevelDonePic:
.db %11111111,%11111111,%11111111,%11111111
.db %10000000,%00000000,%00000000,%00000001
.db %10010000,%00000000,%00000010,%00000001
.db %10010000,%00000000,%00000010,%00000001
.db %10010000,%11110101,%01111010,%00000001
.db %10010000,%11010101,%01101010,%00000001
.db %10011000,%11110101,%01111010,%00000001
.db %10011000,%11000111,%01100010,%00000001
.db %10011110,%11110110,%01111010,%00000001
.db %10000000,%00000000,%00000000,%00000001
.db %10000111,%11100000,%00000000,%00010001
.db %10000100,%00100000,%00000000,%00010001
.db %10000100,%00101111,%01111011,%11010001
.db %10000100,%00101001,%01001011,%01011001
.db %10000110,%00101001,%01101011,%11011001
.db %10000110,%00101001,%01101011,%00000001
.db %10000111,%11101111,%01101011,%11010001
.db %10000000,%00000000,%00000000,%00000001
.db %11111111,%11111111,%11111111,%11111111

Pic:
  .db %00000000,%00000000,%00000000,%00000011,%11000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000010,%01000000,%00000100,%00000000,%00000000,%00000000,%00000000,%00000001,%00000111,%10000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000010,%01000000,%00000000,%00000000,%01000000,%00000000,%00000000,%00000001,%00000100,%10000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000011,%11001110,%11110101,%11101110,%11101111,%10111011,%11111000,%01101001,%00000100,%10000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000011,%00101010,%00010101,%00101000,%01101000,%10101010,%01001000,%01101001,%00000100,%10000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000011,%00101000,%11110101,%10101110,%01001000,%10100011,%01001000,%01101001,%10000100,%10000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000011,%00101100,%11010101,%10100110,%01001000,%10110011,%01001000,%00110001,%10000100,%10000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000011,%11101100,%11111101,%10101110,%01101111,%10110011,%01001000,%00110001,%10010111,%10000000,%00000000,%00000000,%00000000

StartTxt:
    .db "Start",0
HiTxt:
    .db "Highscore",0
InstTxt:
    .db "Instructions",0
QuitTxt:
    .db "Quit",0
CopyTxt:
    .db "(c)2002 Andreas Finne",0
MailTxt:
    .db "andreas@calc.org",0

NewHighTxt:
    .db "New highscore!",0
EnterNameTxt:
    .db "Enter your name:",0

Number0:
.db %01000000
.db %10100000
.db %10100000
.db %10100000
.db %01000000
.db %00000000
.db %00000000
.db %00000000

Number1:
.db %01000000
.db %11000000
.db %01000000
.db %01000000
.db %11100000
.db %00000000
.db %00000000
.db %00000000

Number2:
.db %11000000
.db %00100000
.db %01000000
.db %10000000
.db %11100000
.db %00000000
.db %00000000
.db %00000000

Number3:
.db %11000000
.db %00100000
.db %01000000
.db %00100000
.db %11000000
.db %00000000
.db %00000000
.db %00000000

Number4:
.db %10000000
.db %10100000
.db %11100000
.db %00100000
.db %00100000
.db %00000000
.db %00000000
.db %00000000

Number5:
.db %11100000
.db %10000000
.db %11000000
.db %00100000
.db %11000000
.db %00000000
.db %00000000
.db %00000000

Number6:
.db %01100000
.db %10000000
.db %11100000
.db %10100000
.db %11100000
.db %00000000
.db %00000000
.db %00000000

Number7:
.db %11100000
.db %00100000
.db %01000000
.db %10000000
.db %10000000
.db %00000000
.db %00000000
.db %00000000

Number8:
.db %11100000
.db %10100000
.db %11100000
.db %10100000
.db %11100000
.db %00000000
.db %00000000
.db %00000000

Number9:
.db %11100000
.db %10100000
.db %11100000
.db %00100000
.db %11000000
.db %00000000
.db %00000000
.db %00000000

Levels:
Level1:
    .db 1,1,1,0,0,0,0,0,0,1,1,1
    .db 1,1,1,0,0,0,0,0,0,1,1,1
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 1,1,1,0,0,0,0,0,0,1,1,1
    .db 1,1,1,0,0,0,0,0,0,1,1,1

Level2:
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 0,0,0,2,2,2,2,2,2,0,0,0
    .db 0,0,0,2,1,1,1,1,2,0,0,0
    .db 0,0,0,2,1,1,1,1,2,0,0,0
    .db 0,0,0,2,1,1,1,1,2,0,0,0
    .db 0,0,0,2,2,2,2,2,2,0,0,0
    .db 0,0,0,0,0,0,0,0,0,0,0,0

Level3:
    .db 2,2,0,0,0,0,0,0,0,0,1,1
    .db 1,1,0,0,0,0,0,0,0,0,2,2
    .db 1,1,0,0,0,0,0,0,0,0,2,2
    .db 1,1,0,0,0,0,0,0,0,0,2,2
    .db 1,1,0,0,0,0,0,0,0,0,2,2
    .db 1,1,0,0,0,0,0,0,0,0,2,2
    .db 2,2,0,0,0,0,0,0,0,0,1,1

Level4:
    .db 2,2,2,2,0,0,0,0,2,2,2,2
    .db 2,1,1,2,0,0,0,0,2,1,1,2
    .db 2,1,1,2,0,0,0,0,2,1,1,2
    .db 2,2,2,2,0,0,0,0,2,2,2,2
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 0,0,0,0,0,0,0,0,0,0,0,0

Level5:
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 0,0,1,2,2,2,2,2,2,1,0,0
    .db 0,0,1,1,2,3,3,2,1,1,0,0
    .db 0,0,1,1,3,3,3,3,1,1,0,0
    .db 0,0,1,1,2,3,3,2,1,1,0,0
    .db 0,0,1,2,2,2,2,2,2,1,0,0
    .db 0,0,0,0,0,0,0,0,0,0,0,0

Level6:
    .db 0,0,0,2,1,1,1,1,2,0,0,0
    .db 0,0,0,2,2,1,1,2,2,0,0,0
    .db 0,0,0,0,2,1,1,2,0,0,0,0
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 0,0,0,0,2,1,1,2,0,0,0,0
    .db 0,0,0,2,2,1,1,2,2,0,0,0
    .db 0,0,0,2,1,1,1,1,2,0,0,0

Level7:
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 0,1,1,0,0,2,2,0,0,1,1,0
    .db 0,1,1,0,0,2,2,0,0,1,1,0
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 0,2,2,0,0,1,1,0,0,2,2,0
    .db 0,2,2,0,0,1,1,0,0,2,2,0
    .db 0,0,0,0,0,0,0,0,0,0,0,0

Level8:
    .db 3,3,0,0,0,0,0,0,0,0,3,3
    .db 3,3,2,2,0,0,0,0,2,2,3,3
    .db 0,2,2,0,1,1,1,1,0,2,2,0
    .db 0,0,0,0,1,1,1,1,0,0,0,0
    .db 0,2,2,0,1,1,1,1,0,2,2,0
    .db 3,3,2,2,0,0,0,0,2,2,3,3
    .db 3,3,0,0,0,0,0,0,0,0,3,3

Level9:
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 0,1,0,0,2,0,0,2,0,0,1,0
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 1,1,1,1,0,0,0,0,1,1,1,1
    .db 1,2,2,1,0,0,0,0,1,2,2,1
    .db 1,2,2,1,0,0,0,0,1,2,2,1
    .db 1,1,1,1,0,0,0,0,1,1,1,1

Level10:
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 0,3,3,3,0,0,0,0,1,1,1,0
    .db 0,0,0,0,0,2,0,0,0,0,0,0
    .db 0,3,0,0,0,2,0,0,1,0,0,0
    .db 0,3,0,0,0,2,0,0,1,0,0,0
    .db 0,3,0,0,0,0,0,0,1,0,0,0
    .db 0,0,0,2,2,2,0,0,0,0,0,0

Level11:
    .db 0,0,1,1,1,1,1,1,1,1,0,0
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 0,0,2,2,2,2,2,2,2,2,0,0
    .db 0,0,2,2,2,2,2,2,2,2,0,0
    .db 0,0,2,2,2,2,2,2,2,2,0,0
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 0,0,1,1,1,1,1,1,1,1,0,0

Level12:
    .db 0,1,3,3,0,0,0,0,0,1,3,3
    .db 1,1,1,3,3,0,0,0,1,1,1,3
    .db 0,1,3,3,0,2,2,3,3,1,3,3
    .db 0,0,0,0,2,2,2,2,3,3,0,0
    .db 0,1,3,3,0,2,2,3,3,1,3,3
    .db 1,1,1,3,3,0,0,0,1,1,1,3
    .db 0,1,3,3,0,0,0,0,0,1,3,3

Level13:
    .db 0,0,3,0,0,3,3,0,0,3,0,0
    .db 0,2,3,2,2,2,2,2,2,3,2,0
    .db 0,0,3,0,0,3,3,0,0,3,0,0
    .db 0,1,1,1,1,3,3,1,1,1,1,0
    .db 0,0,3,0,0,3,3,0,0,3,0,0
    .db 0,2,3,2,2,2,2,2,2,3,2,0
    .db 0,0,3,0,0,3,3,0,0,3,0,0

Level14:
    .db 0,1,1,1,1,1,1,1,1,1,1,0
    .db 0,1,3,3,3,3,3,3,3,3,1,0
    .db 0,1,3,3,3,3,3,3,3,3,1,0
    .db 0,1,1,1,1,1,1,1,1,1,1,0
    .db 2,2,2,0,0,0,0,0,0,2,2,2
    .db 2,2,2,0,0,0,0,0,0,2,2,2
    .db 2,2,2,0,0,0,0,0,0,2,2,2

Level15:
    .db 1,1,1,1,1,1,1,1,1,1,1,1
    .db 1,0,0,0,0,0,0,0,0,0,0,1
    .db 1,0,2,2,2,2,2,2,2,2,0,1
    .db 1,0,2,0,3,3,3,3,0,2,0,1
    .db 1,0,2,2,2,2,2,2,2,2,0,1
    .db 1,0,0,0,0,0,0,0,0,0,0,1
    .db 1,1,1,1,1,1,1,1,1,1,1,1

Level16:
    .db 0,1,1,1,0,2,2,0,1,1,1,0
    .db 0,1,1,1,0,2,2,0,1,1,1,0
    .db 0,0,0,0,0,2,2,0,0,0,0,0
    .db 2,2,2,2,2,2,2,2,2,2,2,2
    .db 0,0,0,0,0,2,2,0,0,0,0,0
    .db 0,1,1,1,0,2,2,0,1,1,1,0
    .db 0,1,1,1,0,2,2,0,1,1,1,0

Level17:
    .db 3,3,3,1,1,1,1,1,1,3,3,3
    .db 3,3,3,1,1,1,1,1,1,3,3,3
    .db 3,3,3,3,3,3,3,3,3,3,3,3
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 3,3,3,3,3,3,3,3,3,3,3,3
    .db 3,3,3,2,2,2,2,2,2,3,3,3
    .db 3,3,3,2,2,2,2,2,2,3,3,3

Level18:
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 0,1,2,2,2,2,2,2,2,2,1,0
    .db 0,1,1,2,1,2,1,2,1,2,1,0
    .db 0,1,2,1,2,1,2,1,2,1,1,0
    .db 0,1,1,2,1,2,1,2,1,2,1,0
    .db 0,1,2,2,2,2,2,2,2,2,1,0
    .db 0,0,0,0,0,0,0,0,0,0,0,0

Level19:
    .db 2,2,2,0,0,0,0,0,0,0,0,0
    .db 0,0,0,2,2,2,0,0,0,0,0,0
    .db 1,0,0,0,0,0,2,2,2,0,0,0
    .db 1,1,0,0,0,0,0,0,0,2,2,2
    .db 1,0,0,0,0,0,2,2,2,0,0,0
    .db 0,0,0,2,2,2,0,0,0,0,0,0
    .db 2,2,2,0,0,0,0,0,0,0,0,0

Level20:
    .db 0,0,3,3,0,0,1,1,0,0,2,2
    .db 0,2,3,3,0,3,1,1,0,1,2,2
    .db 1,2,2,0,2,3,3,0,3,1,1,0
    .db 1,1,0,0,2,2,0,0,3,3,0,0
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 0,0,0,0,0,0,0,0,0,0,0,0
    .db 0,0,0,0,0,0,0,0,0,0,0,0

InstructionsText:
PageOne:
.db "Move the three lines to",0
.db "trap the ball over dark",0
.db "gray squares. Select a line",0
.db "from the control panel on",0
.db "the right, and move the",0
.db "pointer over the playing",0

PageTwo:
.db "area and press 2nd to make",0
.db "the line flow towards the",0
.db "pointer.",0
.db "Each of the 20 levels is",0
.db "played against a time limit.",0
.db "In order to successfully",0

PageThree:
.db "complete a level, your",0
.db "score must be greater than",0
.db "at the end of the previous",0
.db "level. Your current score",0
.db "is to the left, and the score",0
.db "to beat is to the right.",0

PageFour:
.db "Dark gray increases your",0
.db "score. Light gray reduces",0
.db "it. Dotted causes the ball to",0
.db "appear somewhere else on",0
.db "the playing area.",0
.db "The BONUS icon doubles the",0

PageFive:
.db "scoring speed, be it positive",0
.db "or negative.",0
.db "Keys:",0
.db "Arrows    Move pointer",0
.db "2nd    Draw/select line",0
.db "Exit    Return to menu",0

HighScores:
.db 'n','o','n','e',' ',' ',' ',' ',0
.dw 100
.db 'n','o','n','e',' ',' ',' ',' ',0
.dw 100
.db 'n','o','n','e',' ',' ',' ',' ',0
.dw 100
.db 'n','o','n','e',' ',' ',' ',' ',0
.dw 100
HighScoresEnd:

.end
